# RandomizeBookStack.py (Prototype 0.00)
# Test script for adding Ajax Easypose style ERC to a figure.

# 0.00: 


import poser,random

# I put my scripts into a class simply to avoid possible conflict with stuff in the __main__ module.
class cheapskatesTemporaryClass(object):
	
	# List of all the BookStack4 figures linked underneath the selected one
	figlist = []
	
	def getAnyChildStackFigure(self, thisfig):
		print "getAnyChildStackFigure()"
		
		act = thisfig.ActorByInternalName("top_of_stack")
		actlist = act.Children()
		for a in actlist:
			if a.ItsFigure():
				childfig = a.ItsFigure()
				figname = childfig.Name()
				if figname[:15] == "Four Book Stack":
					print "Adding '" + figname +"' to figlist[]"
					self.figlist.append(figname)
					self.getAnyChildStackFigure(childfig)
					
		return
	
	def main(self):
		
		# Get Poser version for doing version-specific stuff
		poserversion = '0'
		posermainversion = '0'
		try:
			self.poserversion = poser.AppVersion()
			temp = self.poserversion.split('.')
			self.posermainversion = temp[0]
		except:
			pass
			
		
		
			
		# Abort if the user gets cold feet right at the start
		confirmed = poser.DialogSimple.YesNo("This script randomizes the books in the stack.\n\nDo you wish to continue?")
		if not confirmed:
			confirmed = poser.DialogSimple.YesNo("Do you want to see more information about what this script does?\n\n(This opens a debug window with extra information and terminates the script. You'll probably need to resize the debug window to read the information.)")
			if confirmed:
				# Briefly explain to the user what this script does and give an option toabort straight away
				print "This script randomizes the books in the stack... MORE EXPLANATION TO GO HERE"
			return
			
		# Abort if the selected figure's not a BookStack4
		fig = poser.Scene().CurrentFigure()
		if not (fig.Name()[:15] == "Four Book Stack"):
			poser.DialogSimple.MessageBox("This script is only for use with 'Four Book Stack' figures.\n\nScript aborted, no changes made.")
			return
			
		
		print "Adding '" + fig.Name() +"' to figlist[]"
		self.figlist.append(fig.Name())
		
		self.getAnyChildStackFigure(fig)
		
		
			
		
		
		
		
		
		# geometries ?
		geomtoo=poser.DialogSimple.YesNo("Select random alternate geometries?")
		
		# morphs+adjustments ?
		adjtoo=poser.DialogSimple.YesNo("Randomize morphs + adjustments ?")
		
		# yrot ?
		fullyrot = 0
		yrottoo=poser.DialogSimple.YesNo("Randomize yRotations ?")
		if yrottoo:
			fullyrot=poser.DialogSimple.YesNo("Full 360 degrees ?\n(If not +-10 will be used)")
		
		# translations ?
		transtoo=poser.DialogSimple.YesNo("Randomize translations?")
		
		# scaling ?
		scalestoo=poser.DialogSimple.YesNo("Randomize scales?")
		
		# Let user select random grass or bump geometries
		confirm1=poser.DialogSimple.YesNo("Ready to randomize?\n(final confirmation)")
		if confirm1:
			
			for f in self.figlist:
				fig = poser.Scene().Figure(f)
				print fig.Name()
				# For each of the four books in the figure...
				i = 1
				while i < 5:
					# Get the next book
					bone = "book_" + str(i)
					act = fig.ActorByInternalName(bone)
					print "Randomizing " + bone
									
					# Randomize geometry
					if geomtoo:
						pname = "Book" + str(i)+"Geom"
						p = act.Parameter(pname)
						rand = random.randint(p.MinValue(),p.MaxValue()) #int, can be negative
						p.SetValue(rand)
					
					if adjtoo:
						# Randomize 'Splay'
						p = act.Parameter("Splay")
						rand = random.uniform(p.MinValue(),p.MaxValue())
						p.SetValue(rand)
						
						# Randomize 'Oblique'
						p = act.Parameter("Oblique")
						rand = random.uniform(p.MinValue(),p.MaxValue())
						p.SetValue(rand)
						
						# Randomize 'Shear'
						p = act.Parameter("Shear")
						rand = random.uniform(p.MinValue(),p.MaxValue())
						p.SetValue(rand)
						
						# Randomize 'Plump' - OVERRIDE -1 MINIMUM VALUE, USE 0
						p = act.Parameter("Plump")
						rand = random.uniform(0,p.MaxValue()) #float, can be negative
						p.SetValue(rand)
						
						# Randomize 'Shear'
						p = act.Parameter("Shear")
						rand = random.uniform(p.MinValue(),p.MaxValue())
						p.SetValue(rand)
						
						# Randomize 'Twist'
						p = act.Parameter("Twist")
						rand = random.uniform(p.MinValue(),p.MaxValue())
						p.SetValue(rand)
						
						# Randomize 'Curl (Paperback only)' - BEST NOT TO DO THIS VIA SCRIPT
						#p = act.Parameter("Curl (Paperback only)")
						#rand = random.uniform(p.MinValue(),p.MaxValue())
						#p.SetValue(rand)
					
					# Randomize 'yRotate'
					if yrottoo:
						pmin=0
						pmax=0
						if fullyrot:
							pmin=p.MinValue()
							pmax=p.MaxValue()
						else:
							pmin=-10
							pmax=10
						p = act.Parameter("yRotate")
						rand = random.uniform(pmin,pmax)
						p.SetValue(rand)
					
					if transtoo:
						# Randomize 'xTran'
						p = act.Parameter("xTran")
						rand = random.uniform(p.MinValue(),p.MaxValue())
						p.SetValue(rand)
						
						# Randomize 'zTran'
						p = act.Parameter("zTran")
						rand = random.uniform(p.MinValue(),p.MaxValue())
						p.SetValue(rand)
					
					if scalestoo:
						# Randomize 'Scale'
						p = act.Parameter("Scale")
						rand = random.uniform(p.MinValue(),p.MaxValue())
						p.SetValue(rand)
						
						# Randomize 'xScale'
						p = act.Parameter("xScale")
						rand = random.uniform(p.MinValue(),p.MaxValue())
						p.SetValue(rand)
						
						# Randomize 'yScale'
						p = act.Parameter("yScale")
						rand = random.uniform(p.MinValue(),p.MaxValue())
						p.SetValue(rand)
						
						# Randomize 'zScale'
						p = act.Parameter("zScale")
						rand = random.uniform(p.MinValue(),p.MaxValue())
						p.SetValue(rand)
					
					# Next book if any
					i = i + 1
				
		# Redraw what we've modified	
		poser.Scene().Draw()
			
		# Inform the user that it's all done
		poser.DialogSimple.MessageBox("All done")
			
poser.DialogSimple.MessageBox("Running 3DCheapskates RandomizeBookStack.py script (prototype 0.00)\n\n(N.B. You should see a similar message when the script finishes. If you don't then the script has crashed!)")
cheapskatesTemporaryInstance = cheapskatesTemporaryClass()
cheapskatesTemporaryInstance.main()
poser.DialogSimple.MessageBox("3DCheapskates RandomizeBookStack.py script (prototype 0.00) all done.")